Index: /palm/trunk/SOURCE/modules.f90
===================================================================
--- /palm/trunk/SOURCE/modules.f90	(revision 1319)
+++ /palm/trunk/SOURCE/modules.f90	(revision 1320)
@@ -1306,41 +1120,41 @@
              'not_used        ' /)
 
-    INTEGER ::  id_dim_prtnum, id_dim_time_pr, id_dim_time_prt, &
-                id_dim_time_pts, id_dim_time_sp, id_dim_time_ts, id_dim_x_sp, &
-                id_dim_y_sp, id_dim_zu_sp, id_dim_zw_sp, id_set_pr, &
-                id_set_prt, id_set_pts, id_set_sp, id_set_ts, id_var_prtnum, &
-                id_var_rnop_prt, id_var_time_pr, id_var_time_prt, &
-                id_var_time_pts, id_var_time_sp, id_var_time_ts, id_var_x_sp, &
-                id_var_y_sp, id_var_zu_sp, id_var_zw_sp, nc_stat
-
-    INTEGER, DIMENSION(0:1) ::  id_dim_time_xy, id_dim_time_xz, &
-                id_dim_time_yz, id_dim_time_3d, id_dim_x_xy, id_dim_xu_xy, &
-                id_dim_x_xz, id_dim_xu_xz, id_dim_x_yz, id_dim_xu_yz, &
-                id_dim_x_3d, id_dim_xu_3d, id_dim_y_xy, id_dim_yv_xy, &
-                id_dim_y_xz, id_dim_yv_xz, id_dim_y_yz, id_dim_yv_yz, &
-                id_dim_y_3d, id_dim_yv_3d, id_dim_zu_xy, id_dim_zu1_xy, &
-                id_dim_zu_xz, id_dim_zu_yz, id_dim_zu_3d, id_dim_zw_xy, &
-                id_dim_zw_xz, id_dim_zw_yz, id_dim_zw_3d, id_set_xy, &
-                id_set_xz, id_set_yz, id_set_3d, id_var_ind_x_yz, &
-                id_var_ind_y_xz, id_var_ind_z_xy, id_var_time_xy, &
-                id_var_time_xz, id_var_time_yz, id_var_time_3d, id_var_x_xy, &
-                id_var_xu_xy, id_var_x_xz, id_var_xu_xz, id_var_x_yz, &
-                id_var_xu_yz, id_var_x_3d, id_var_xu_3d, id_var_y_xy, &
-                id_var_yv_xy, id_var_y_xz, id_var_yv_xz, id_var_y_yz, &
-                id_var_yv_yz, id_var_y_3d, id_var_yv_3d, id_var_zusi_xy, &
-                id_var_zusi_3d, id_var_zu_xy, id_var_zu1_xy, id_var_zu_xz, &
-                id_var_zu_yz, id_var_zu_3d, id_var_zwwi_xy, id_var_zwwi_3d, &
-                id_var_zw_xy, id_var_zw_xz, id_var_zw_yz, id_var_zw_3d
-
-    INTEGER, DIMENSION(10)  ::  id_var_dospx, id_var_dospy
-    INTEGER, DIMENSION(20)  ::  id_var_prt
-    INTEGER, DIMENSION(11)  ::  nc_precision
-    INTEGER, DIMENSION(dopr_norm_num) ::  id_var_norm_dopr
-
-    INTEGER, DIMENSION(dopts_num,0:10) ::  id_var_dopts
-    INTEGER, DIMENSION(0:1,100)        ::  id_var_do2d, id_var_do3d
-    INTEGER, DIMENSION(100,0:9)        ::  id_dim_z_pr, id_var_dopr, &
-                                           id_var_z_pr
-    INTEGER, DIMENSION(dots_max,0:9)   ::  id_var_dots
+    INTEGER(iwp) ::  id_dim_prtnum, id_dim_time_pr, id_dim_time_prt, &
+                     id_dim_time_pts, id_dim_time_sp, id_dim_time_ts, id_dim_x_sp, &
+                     id_dim_y_sp, id_dim_zu_sp, id_dim_zw_sp, id_set_pr, &
+                     id_set_prt, id_set_pts, id_set_sp, id_set_ts, id_var_prtnum, &
+                     id_var_rnop_prt, id_var_time_pr, id_var_time_prt, &
+                     id_var_time_pts, id_var_time_sp, id_var_time_ts, id_var_x_sp, &
+                     id_var_y_sp, id_var_zu_sp, id_var_zw_sp, nc_stat
+
+    INTEGER(iwp), DIMENSION(0:1) ::  id_dim_time_xy, id_dim_time_xz, &
+                    id_dim_time_yz, id_dim_time_3d, id_dim_x_xy, id_dim_xu_xy, &
+                    id_dim_x_xz, id_dim_xu_xz, id_dim_x_yz, id_dim_xu_yz, &
+                    id_dim_x_3d, id_dim_xu_3d, id_dim_y_xy, id_dim_yv_xy, &
+                    id_dim_y_xz, id_dim_yv_xz, id_dim_y_yz, id_dim_yv_yz, &
+                    id_dim_y_3d, id_dim_yv_3d, id_dim_zu_xy, id_dim_zu1_xy, &
+                    id_dim_zu_xz, id_dim_zu_yz, id_dim_zu_3d, id_dim_zw_xy, &
+                    id_dim_zw_xz, id_dim_zw_yz, id_dim_zw_3d, id_set_xy, &
+                    id_set_xz, id_set_yz, id_set_3d, id_var_ind_x_yz, &
+                    id_var_ind_y_xz, id_var_ind_z_xy, id_var_time_xy, &
+                    id_var_time_xz, id_var_time_yz, id_var_time_3d, id_var_x_xy, &
+                    id_var_xu_xy, id_var_x_xz, id_var_xu_xz, id_var_x_yz, &
+                    id_var_xu_yz, id_var_x_3d, id_var_xu_3d, id_var_y_xy, &
+                    id_var_yv_xy, id_var_y_xz, id_var_yv_xz, id_var_y_yz, &
+                    id_var_yv_yz, id_var_y_3d, id_var_yv_3d, id_var_zusi_xy, &
+                    id_var_zusi_3d, id_var_zu_xy, id_var_zu1_xy, id_var_zu_xz, &
+                    id_var_zu_yz, id_var_zu_3d, id_var_zwwi_xy, id_var_zwwi_3d, &
+                    id_var_zw_xy, id_var_zw_xz, id_var_zw_yz, id_var_zw_3d
+
+    INTEGER(iwp), DIMENSION(10)  ::  id_var_dospx, id_var_dospy
+    INTEGER(iwp), DIMENSION(20)  ::  id_var_prt
+    INTEGER(iwp), DIMENSION(11)  ::  nc_precision
+    INTEGER(iwp), DIMENSION(dopr_norm_num) ::  id_var_norm_dopr
+
+    INTEGER(iwp), DIMENSION(dopts_num,0:10) ::  id_var_dopts
+    INTEGER(iwp), DIMENSION(0:1,100)        ::  id_var_do2d, id_var_do3d
+    INTEGER(iwp), DIMENSION(100,0:9)        ::  id_dim_z_pr, id_var_dopr, &
+                                               id_var_z_pr
+    INTEGER(iwp), DIMENSION(dots_max,0:9)   ::  id_var_dots
 
 !
@@ -1350,13 +1164,13 @@
     LOGICAL ::  output_for_t0 = .FALSE.
 
-    INTEGER, DIMENSION(1:max_masks,0:1) ::  id_dim_time_mask, id_dim_x_mask, &
-                id_dim_xu_mask, id_dim_y_mask, id_dim_yv_mask, id_dim_zu_mask, &
-                id_dim_zw_mask, &
-                id_set_mask, &
-                id_var_time_mask, id_var_x_mask, id_var_xu_mask, &
-                id_var_y_mask, id_var_yv_mask, id_var_zu_mask, id_var_zw_mask, &
-                id_var_zusi_mask, id_var_zwwi_mask
-
-    INTEGER, DIMENSION(1:max_masks,0:1,100)         ::  id_var_domask
+    INTEGER(iwp), DIMENSION(1:max_masks,0:1) ::  id_dim_time_mask, id_dim_x_mask, &
+                   id_dim_xu_mask, id_dim_y_mask, id_dim_yv_mask, id_dim_zu_mask, &
+                   id_dim_zw_mask, &
+                   id_set_mask, &
+                   id_var_time_mask, id_var_x_mask, id_var_xu_mask, &
+                   id_var_y_mask, id_var_yv_mask, id_var_zu_mask, id_var_zw_mask, &
+                   id_var_zusi_mask, id_var_zwwi_mask
+
+    INTEGER(iwp), DIMENSION(1:max_masks,0:1,100)         ::  id_var_domask
 
     SAVE
@@ -1374,5 +1188,5 @@
 !------------------------------------------------------------------------------!
 
-    USE precision_kind
+    USE kinds
 
     CHARACTER (LEN=15)  ::  bc_par_lr = 'cyclic',  bc_par_ns = 'cyclic', &
@@ -1380,29 +1194,27 @@
                             collision_kernel = 'none'
 
-#if defined( __parallel )
-    INTEGER ::  mpi_particle_type
-#endif
-    INTEGER ::  deleted_particles = 0, deleted_tails = 0,                      &
-                dissipation_classes = 10, ibc_par_lr,                          &
-                ibc_par_ns, ibc_par_b, ibc_par_t, iran_part = -1234567,        &
-                maximum_number_of_particles = 1000,                            &
-                maximum_number_of_tailpoints = 100,                            &
-                maximum_number_of_tails = 0,                                   &
-                number_of_sublayers = 20,                                      &
-                number_of_initial_particles = 0, number_of_particles = 0,      &
-                number_of_particle_groups = 1, number_of_tails = 0,            &
-                number_of_initial_tails = 0, offset_ocean_nzt = 0,             &
-                offset_ocean_nzt_m1 = 0, particles_per_point = 1,              &
-                particle_file_count = 0, radius_classes = 20,                  &
-                skip_particles_for_tail = 100, sort_count = 0,                 &
-                total_number_of_particles, total_number_of_tails = 0,          &
-                trlp_count_sum, trlp_count_recv_sum, trrp_count_sum,           &
-                trrp_count_recv_sum, trsp_count_sum, trsp_count_recv_sum,      &
-                trnp_count_sum, trnp_count_recv_sum
-
-    INTEGER, PARAMETER ::  max_number_of_particle_groups = 10
-
-    INTEGER, DIMENSION(:), ALLOCATABLE     ::  new_tail_id
-    INTEGER, DIMENSION(:,:,:), ALLOCATABLE ::  prt_count, prt_start_index
+    INTEGER(iwp) ::  deleted_particles = 0, deleted_tails = 0,                      &
+                     dissipation_classes = 10, ibc_par_lr,                          &
+                     ibc_par_ns, ibc_par_b, ibc_par_t, iran_part = -1234567,        &
+                     maximum_number_of_particles = 1000,                            &
+                     maximum_number_of_tailpoints = 100,                            &
+                     maximum_number_of_tails = 0,                                   &
+                     mpi_particle_type,                                             &
+                     number_of_sublayers = 20,                                      &
+                     number_of_initial_particles = 0, number_of_particles = 0,      &
+                     number_of_particle_groups = 1, number_of_tails = 0,            &
+                     number_of_initial_tails = 0, offset_ocean_nzt = 0,             &
+                     offset_ocean_nzt_m1 = 0, particles_per_point = 1,              &
+                     particle_file_count = 0, radius_classes = 20,                  &
+                     skip_particles_for_tail = 100, sort_count = 0,                 &
+                     total_number_of_particles, total_number_of_tails = 0,          &
+                     trlp_count_sum, trlp_count_recv_sum, trrp_count_sum,           &
+                     trrp_count_recv_sum, trsp_count_sum, trsp_count_recv_sum,      &
+                     trnp_count_sum, trnp_count_recv_sum
+
+    INTEGER(iwp), PARAMETER ::  max_number_of_particle_groups = 10
+
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE     ::  new_tail_id
+    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  prt_count, prt_start_index
 
     LOGICAL ::  hall_kernel = .FALSE., palm_kernel = .FALSE.,                  &
@@ -1418,32 +1230,32 @@
     LOGICAL, DIMENSION(:), ALLOCATABLE ::  particle_mask, tail_mask
 
-    REAL    ::  c_0 = 3.0, dt_min_part = 0.0002, dt_prel = 9999999.9,          &
-                dt_sort_particles = 0.0, dt_write_particle_data = 9999999.9,   &
-                dvrp_psize = 9999999.9, end_time_prel = 9999999.9,             &
-                initial_weighting_factor = 1.0,                                &
-                maximum_tailpoint_age = 100000.0,                              &
-                minimum_tailpoint_distance = 0.0,                              &
-                particle_advection_start = 0.0, sgs_wfu_part = 0.3333333,      &
-                sgs_wfv_part = 0.3333333, sgs_wfw_part = 0.3333333,            &
-                time_prel = 0.0, time_sort_particles = 0.0,                    &
-                time_write_particle_data = 0.0, z0_av_global
-
-    REAL, DIMENSION(max_number_of_particle_groups) ::  &
-                density_ratio = 9999999.9, pdx = 9999999.9, pdy = 9999999.9, &
-                pdz = 9999999.9, psb = 9999999.9, psl = 9999999.9,           &
-                psn = 9999999.9, psr = 9999999.9, pss = 9999999.9,           &
-                pst = 9999999.9, radius = 9999999.9
-
-    REAL, DIMENSION(:), ALLOCATABLE     ::  log_z_z0 
-
-    REAL, DIMENSION(:,:,:), ALLOCATABLE ::  particle_tail_coordinates
+    REAL(wp)    ::  c_0 = 3.0, dt_min_part = 0.0002, dt_prel = 9999999.9,          &
+                    dt_sort_particles = 0.0, dt_write_particle_data = 9999999.9,   &
+                    dvrp_psize = 9999999.9, end_time_prel = 9999999.9,             &
+                    initial_weighting_factor = 1.0,                                &
+                    maximum_tailpoint_age = 100000.0,                              &
+                    minimum_tailpoint_distance = 0.0,                              &
+                    particle_advection_start = 0.0, sgs_wfu_part = 0.3333333,      &
+                    sgs_wfv_part = 0.3333333, sgs_wfw_part = 0.3333333,            &
+                    time_prel = 0.0, time_sort_particles = 0.0,                    &
+                    time_write_particle_data = 0.0, z0_av_global
+
+    REAL(wp), DIMENSION(max_number_of_particle_groups) ::  &
+                    density_ratio = 9999999.9, pdx = 9999999.9, pdy = 9999999.9, &
+                    pdz = 9999999.9, psb = 9999999.9, psl = 9999999.9,           &
+                    psn = 9999999.9, psr = 9999999.9, pss = 9999999.9,           &
+                    pst = 9999999.9, radius = 9999999.9
+
+    REAL(wp), DIMENSION(:), ALLOCATABLE     ::  log_z_z0 
+
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  particle_tail_coordinates
 
 
     TYPE particle_type
        SEQUENCE
-       REAL    ::  age, age_m, dt_sum, dvrp_psize, e_m, origin_x, origin_y, &
-                   origin_z, radius, rvar1, rvar2, rvar3, speed_x, speed_y, &
-                   speed_z, weight_factor, x, y, z
-       INTEGER ::  class, group, tailpoints, tail_id
+       REAL(wp)    ::  age, age_m, dt_sum, dvrp_psize, e_m, origin_x, origin_y, &
+                       origin_z, radius, rvar1, rvar2, rvar3, speed_x, speed_y, &
+                       speed_z, weight_factor, x, y, z
+       INTEGER(iwp) ::  class, group, tailpoints, tail_id
     END TYPE particle_type
 
@@ -1454,5 +1266,5 @@
     TYPE particle_groups_type
        SEQUENCE
-       REAL    ::  density_ratio, radius, exp_arg, exp_term
+       REAL(wp)    ::  density_ratio, radius, exp_arg, exp_term
     END TYPE particle_groups_type
 
@@ -1477,4 +1289,6 @@
 ! MPI-calls.
 !------------------------------------------------------------------------------!
+
+    USE kinds
 
 #if defined( __parallel ) && ! defined ( __check )
@@ -1487,20 +1301,20 @@
     CHARACTER(LEN=2) ::  send_receive = 'al'
     CHARACTER(LEN=5) ::  myid_char = ''
-    INTEGER          ::  acc_rank, comm1dx, comm1dy, comm2d, comm_inter,       &
-                         comm_palm, id_inflow = 0, id_recycling = 0, ierr,     &
-                         myid = 0, myidx = 0, myidy = 0, ndim = 2, ngp_a,      &
-                         ngp_o, ngp_xy, ngp_y, npex = -1, npey = -1,           &
-                         numprocs = 1, numprocs_previous_run = -1,             &
-                         num_acc_per_node = 0, pleft, pnorth, pright, psouth,  &
-                         req_count = 0, sendrecvcount_xy, sendrecvcount_yz,    &
-                         sendrecvcount_zx, sendrecvcount_zyd,                  &
-                         sendrecvcount_yxd, target_id, tasks_per_node = -9999, &
-                         threads_per_task = 1, type_x, type_x_int, type_xy,    &
-                         type_y, type_y_int
-
-    INTEGER          ::  pdims(2) = 1, req(100)
-
-    INTEGER, DIMENSION(:,:), ALLOCATABLE ::  hor_index_bounds, &
-                                             hor_index_bounds_previous_run
+    INTEGER(iwp)          ::  acc_rank, comm1dx, comm1dy, comm2d, comm_inter,       &
+                              comm_palm, id_inflow = 0, id_recycling = 0, ierr,     &
+                              myid = 0, myidx = 0, myidy = 0, ndim = 2, ngp_a,      &
+                              ngp_o, ngp_xy, ngp_y, npex = -1, npey = -1,           &
+                              numprocs = 1, numprocs_previous_run = -1,             &
+                              num_acc_per_node = 0, pleft, pnorth, pright, psouth,  &
+                              req_count = 0, sendrecvcount_xy, sendrecvcount_yz,    &
+                              sendrecvcount_zx, sendrecvcount_zyd,                  &
+                              sendrecvcount_yxd, target_id, tasks_per_node = -9999, &
+                              threads_per_task = 1, type_x, type_x_int, type_xy,    &
+                              type_y, type_y_int
+
+    INTEGER(iwp)          ::  pdims(2) = 1, req(100)
+
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  hor_index_bounds, &
+                                                  hor_index_bounds_previous_run
 
     LOGICAL ::  background_communication =.FALSE., collective_wait = .FALSE., &
@@ -1512,13 +1326,13 @@
 #endif
 
-    INTEGER ::  ibuf(12), pcoord(2)
+    INTEGER(iwp) ::  ibuf(12), pcoord(2)
 
 #if ! defined ( __check )
-    INTEGER ::  status(MPI_STATUS_SIZE)
-    INTEGER, DIMENSION(MPI_STATUS_SIZE,100) ::  wait_stat
+    INTEGER(iwp) ::  status(MPI_STATUS_SIZE)
+    INTEGER(iwp), DIMENSION(MPI_STATUS_SIZE,100) ::  wait_stat
 #endif
 
 
-    INTEGER, DIMENSION(:), ALLOCATABLE ::  ngp_yz, type_xz, type_yz
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  ngp_yz, type_xz, type_yz
 
     LOGICAL ::  left_border_pe  = .FALSE., north_border_pe = .FALSE., &
@@ -1545,5 +1359,7 @@
 !------------------------------------------------------------------------------!
 
-    INTEGER, PARAMETER ::  crmax = 100
+    USE kinds
+
+    INTEGER(iwp), PARAMETER ::  crmax = 100
 
     CHARACTER (LEN=20), DIMENSION(20) ::  cross_ts_profiles = &
@@ -1565,24 +1381,24 @@
                          ( '                               ', i9 = 1, 94 ) /)
 
-    INTEGER ::  profile_columns = 2, profile_rows = 3, profile_number = 0
-
-    INTEGER ::  cross_ts_numbers(crmax,crmax) = 0, &
-                cross_ts_number_count(crmax) = 0, &
-                dopr_index(300) = 0, dopr_initial_index(300) = 0, &
-                dots_crossindex(100) = 0, dots_index(100) = 0
+    INTEGER(iwp) ::  profile_columns = 2, profile_rows = 3, profile_number = 0
+
+    INTEGER(iwp) ::  cross_ts_numbers(crmax,crmax) = 0, &
+                     cross_ts_number_count(crmax) = 0, &
+                     dopr_index(300) = 0, dopr_initial_index(300) = 0, &
+                     dots_crossindex(100) = 0, dots_index(100) = 0
                 
 
-    REAL ::  cross_ts_uymax(20) = &
+    REAL(wp) ::  cross_ts_uymax(20) = &
                              (/ 999.999, 999.999, 999.999, 999.999, 999.999,   &
                                 999.999, 999.999, 999.999, 999.999, 999.999,   &
                                 999.999, 999.999, 999.999, 999.999, 999.999,   &
                                 999.999, 999.999, 999.999, 999.999, 999.999 /),&
-             cross_ts_uymax_computed(20) = 999.999, &
-             cross_ts_uymin(20) = &
+                 cross_ts_uymax_computed(20) = 999.999, &
+                 cross_ts_uymin(20) = &
                              (/ 999.999, 999.999, 999.999,  -5.000, 999.999,   &
                                 999.999,   0.000, 999.999, 999.999, 999.999,   &
                                 999.999, 999.999, 999.999, 999.999, 999.999,   &
                                 999.999, 999.999, 999.999, 999.999, 999.999 /),&
-             cross_ts_uymin_computed(20) = 999.999
+                 cross_ts_uymin_computed(20) = 999.999
 
     SAVE
@@ -1600,4 +1416,6 @@
 ! Definition of quantities used for computing spectra
 !------------------------------------------------------------------------------!
+
+    USE kinds
 
     CHARACTER (LEN=6),  DIMENSION(1:5) ::  header_char = (/ 'PS(u) ', 'PS(v) ',&
@@ -1618,20 +1436,20 @@
                                     'k ^2236 ^2566^2569<q(k) in m>2s>->2    ' /)
 
-    INTEGER ::  klist_x = 0, klist_y = 0, n_sp_x = 0, n_sp_y = 0
-
-    INTEGER ::  comp_spectra_level(100) = 999999,                   &
-                lstyles(100) = (/ 0, 7, 3, 10, 1, 4, 9, 2, 6, 8,    &
-                                  0, 7, 3, 10, 1, 4, 9, 2, 6, 8,    &
-                                  0, 7, 3, 10, 1, 4, 9, 2, 6, 8,    &
-                                  0, 7, 3, 10, 1, 4, 9, 2, 6, 8,    &
-                                  0, 7, 3, 10, 1, 4, 9, 2, 6, 8,    &
-                                  0, 7, 3, 10, 1, 4, 9, 2, 6, 8,    &
-                                  0, 7, 3, 10, 1, 4, 9, 2, 6, 8,    &
-                                  0, 7, 3, 10, 1, 4, 9, 2, 6, 8,    &
-                                  0, 7, 3, 10, 1, 4, 9, 2, 6, 8,    &
-                                  0, 7, 3, 10, 1, 4, 9, 2, 6, 8 /), &
-                plot_spectra_level(100) = 999999
-
-    REAL    ::  time_to_start_sp = 0.0
+    INTEGER(iwp) ::  klist_x = 0, klist_y = 0, n_sp_x = 0, n_sp_y = 0
+
+    INTEGER(iwp) ::  comp_spectra_level(100) = 999999,                   &
+                     lstyles(100) = (/ 0, 7, 3, 10, 1, 4, 9, 2, 6, 8,    &
+                                       0, 7, 3, 10, 1, 4, 9, 2, 6, 8,    &
+                                       0, 7, 3, 10, 1, 4, 9, 2, 6, 8,    &
+                                       0, 7, 3, 10, 1, 4, 9, 2, 6, 8,    &
+                                       0, 7, 3, 10, 1, 4, 9, 2, 6, 8,    &
+                                       0, 7, 3, 10, 1, 4, 9, 2, 6, 8,    &
+                                       0, 7, 3, 10, 1, 4, 9, 2, 6, 8,    &
+                                       0, 7, 3, 10, 1, 4, 9, 2, 6, 8,    &
+                                       0, 7, 3, 10, 1, 4, 9, 2, 6, 8,    &
+                                       0, 7, 3, 10, 1, 4, 9, 2, 6, 8 /), &
+                     plot_spectra_level(100) = 999999
+
+    REAL(wp)    ::  time_to_start_sp = 0.0
 
     SAVE
@@ -1650,25 +1468,27 @@
 !------------------------------------------------------------------------------!
 
+    USE kinds
+
     CHARACTER (LEN=40) ::  region(0:9)
-    INTEGER ::  pr_palm = 90, statistic_regions = 0
-    INTEGER ::  u_max_ijk(3) = -1, v_max_ijk(3) = -1, w_max_ijk(3) = -1
+    INTEGER(iwp) ::  pr_palm = 90, statistic_regions = 0
+    INTEGER(iwp) ::  u_max_ijk(3) = -1, v_max_ijk(3) = -1, w_max_ijk(3) = -1
     LOGICAL ::  flow_statistics_called = .FALSE.
-    REAL ::     u_max, v_max, w_max
-    REAL, DIMENSION(:), ALLOCATABLE       ::  sums_divnew_l, sums_divold_l,   &
-                                              weight_substep, weight_pres
-    REAL, DIMENSION(:,:), ALLOCATABLE     ::  sums, sums_wsts_bc_l, ts_value, &
-                                              sums_wsus_ws_l, sums_wsvs_ws_l, &
-                                              sums_us2_ws_l, sums_vs2_ws_l,   &
-                                              sums_ws2_ws_l,                  &
-                                              sums_wsnrs_ws_l,                &
-                                              sums_wspts_ws_l,                &
-                                              sums_wssas_ws_l,                &
-                                              sums_wsqs_ws_l,                 &
-                                              sums_wsqrs_ws_l
+    REAL(wp) ::     u_max, v_max, w_max
+    REAL(wp), DIMENSION(:), ALLOCATABLE       ::  sums_divnew_l, sums_divold_l,   &
+                                                  weight_substep, weight_pres
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE     ::  sums, sums_wsts_bc_l, ts_value, &
+                                                  sums_wsus_ws_l, sums_wsvs_ws_l, &
+                                                  sums_us2_ws_l, sums_vs2_ws_l,   &
+                                                  sums_ws2_ws_l,                  &
+                                                  sums_wsnrs_ws_l,                &
+                                                  sums_wspts_ws_l,                &
+                                                  sums_wssas_ws_l,                &
+                                                  sums_wsqs_ws_l,                 &
+                                                  sums_wsqrs_ws_l
                                               
-    REAL, DIMENSION(:,:,:), ALLOCATABLE   ::  hom_sum, rmask, spectrum_x, &
-                                              spectrum_y, sums_l, sums_l_l, &
-                                              sums_up_fraction_l
-    REAL, DIMENSION(:,:,:,:), ALLOCATABLE ::  hom
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  hom_sum, rmask, spectrum_x, &
+                                                  spectrum_y, sums_l, sums_l_l, &
+                                                  sums_up_fraction_l
+    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  hom
 
     SAVE
@@ -1687,6 +1507,8 @@
 !------------------------------------------------------------------------------!
 
-    INTEGER ::  nxl_y, nxl_yd, nxl_z, nxr_y, nxr_yd, nxr_z, nyn_x, nyn_z,      &
-                nys_x, nys_z, nzb_x, nzb_y, nzb_yd, nzt_x, nzt_y, nzt_yd
+    USE kinds
+
+    INTEGER(iwp) ::  nxl_y, nxl_yd, nxl_z, nxr_y, nxr_yd, nxr_z, nyn_x, nyn_z,      &
+                     nys_x, nys_z, nzb_x, nzb_y, nzb_yd, nzt_x, nzt_y, nzt_yd
                 
 
